/***************************************************************************
                          IOport8.c  - general purpose debugging function, read/write to 8 bit IO 
                          port (must be root) 
                             -------------------
    begin                : Fri Feb 25 2005
    email                : ngustavson@emacinc.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         																		 *
 *   This program is free software; you can redistribute it and/or modify 				 *
 *   it under the terms of the GNU General Public License as published by  			 *
 *   the Free Software Foundation; either version 2 of the License, or    					 *
 *   (at your option) any later version.                                  												 *
 *                                                                        																			 *
 ***************************************************************************/


#include <sys/io.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/resource.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <asm/types.h>


#define ARGCHECK(num){if(argc<num){printf("invalid number of arguements\n");help();return -1;}}



static int help(void)
{
const char *help_table = 
"**********************************************\n"
"*IOport8                                                                   		\n"
"*Nathan Z. Gustavson                                             	\n"
"*EMAC.Inc                                                                     	\n"
"*"__DATE__"                                                                	\n"
"*usage:                                                                         	\n"
"*IOport8 address data  	                                        	\n"
"*if data is not specified		                              	        \n"
"*an 8 bit value is read from the port                         \n"
"**********************************************\n";
printf("%s",help_table);
return 0;
}


int main(int argc, char *argv[])
{
unsigned int data;
unsigned int address;
	
ARGCHECK(2);	
	
iopl(3);/*change io privilage level, this must be run from root*/

setpriority(PRIO_PROCESS,0,-20);/*jack up priority to speed up access time*/

address = (unsigned int)strtoul(argv[1],NULL,0);

if(argc<3)
	printf("0x%x\n",inb(address)); 
else{
data = (unsigned int)strtoul(argv[2],NULL,0);
outb(data,address);
}

iopl(0);/*return privilage level to 0*/
return 0;
}


















